﻿#load "Refs.fsx"
#time "on"

open FSharp.Control
open Kafunk
open Refs

let Log = Log.create __SOURCE_FILE__

let host = argiDefault 1 "localhost"
let topic = argiDefault 2 "absurd-topic"

let connCfg = KafkaConfig.create ([KafkaUri.parse host], version=Protocol.Versions.V_0_10_1)
let conn = Kafka.conn connCfg

//let offsets = 
//  Offsets.offsets conn topic [] [ Time.EarliestOffset ; Time.LatestOffset ] 1
//  |> Async.RunSynchronously
//
//for kvp in offsets do
//  for (tn,offsets) in kvp.Value.topics do
//    for p in offsets do
//      printfn "time=%i topic=%s p=%i os=%A" kvp.Key tn p.partition p.offsets

let offsets = 
  Offsets.offsetRange conn topic []
  |> Async.RunSynchronously

for kvp in offsets do
  let e,l = kvp.Value
  let c = l - e
  printfn "partition=%i earliest=%i latest=%i count=%i" kvp.Key e l c
